
//+------------------------------------------------------------------+
//|                                                   Kristograf.mq4 |
//|                                    Copyright  2009, K.Piligrimm |
//|                                             piligrimm_fx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, K.Piligrimm"
#property link      "mailto: piligrimm_fx@mail.ru"
#property indicator_chart_window   
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Blue
#property indicator_color4 Red

double PI1,PI2,PI3,VX[],VZ[],VC[],VL[]; 
int i,Pr,Pm;
extern int Threshold1= 47;
extern int Threshold2= 37;
extern int Threshold3= 37;
extern double Kn= 1;
extern int LengthSample=1000;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {

         SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);
         SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,2);
         SetIndexStyle(2, DRAW_LINE,STYLE_SOLID,2);
         SetIndexStyle(3, DRAW_LINE,STYLE_SOLID,2);
    
         SetIndexBuffer(0,VZ);
         SetIndexBuffer(1,VX);
         SetIndexBuffer(2,VC);
         SetIndexBuffer(3,VL);

   if  (Period()==1)
      {  Pr=3; Pm=10; }
    else if  (Period()==5)
      {  Pr=4; Pm=15; }
    else if  (Period()==15)
      {  Pr=5;  Pm=25; }  
    else if  (Period()==30)
      {  Pr=6; Pm=35; }  
    else if  (Period()==60)
      {  Pr=7; Pm=50; }    
    else if  (Period()==240)
      {  Pr=8; Pm=80; }       
    else if  (Period()==1440)
      {  Pr=9; Pm=150; }
    else if  (Period()==10080)
      {  Pr=10; Pm=200; }
    else if  (Period()==43200)
      {  Pr=11; Pm=300; }
        
         ArrayResize(VZ, LengthSample+1);
         ArrayResize(VX, LengthSample+1);
         ArrayResize(VC, LengthSample+1);
         ArrayResize(VL, LengthSample+1);
      
         PI1=Threshold1*Point;
         PI2=Threshold2*Point;
         PI3=Threshold3*Point;

//======================================================================         
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() 
{
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
   {//0
        VX[LengthSample]=(Close[LengthSample]+Open[LengthSample])/2;
        VC[LengthSample]=Low[LengthSample];
        VZ[LengthSample]=High[LengthSample];
        VL[LengthSample]=0.5*VZ[LengthSample]+0.5*VC[LengthSample];
         
    for (i = LengthSample-1; i>=0; i--)
       {  
        VX[i]=(Close[i]+Open[i])/2;   
    if (((MathAbs(VX[i]-VX[i+1])<=PI1*Pr)))
        VX[i]=VX[i+1];
        
        VC[i]=Low[i];   
    if (((MathAbs(VC[i]-VC[i+1])<=PI2*Pr)))
        VC[i]=VC[i+1];
        
        VZ[i]=High[i];
   if (((MathAbs(VZ[i]-VZ[i+1])<=PI3*Pr)))
        VZ[i]=VZ[i+1];
       }
    for (i = LengthSample-1; i>=0; i--)
        VL[i]=Kn*NormalizeDouble((0.8*(0.85*(0.9*(0.9*(0.15*VX[i]+0.85*VL[i+1])+0.1*VZ[i+1])+0.1*VC[i+1])+0.15*((High[i]+Low[i])/2))+0.2*VL[i+1])/Kn,Digits); 

    return(0);
     }//1